/**  Using clipboard - needs a recent version - Chrome is OK - 
 CLICK A COLOR, = COPY to Clipboard */

var nColors = 1819, mousex, mousey, GG, Width = 1260, patchSize = 21;
document.onmousedown = mouseDwn;
//document.onmouseup = mUp;
//document.onmousemove = mRoll;
//document.onkeydown = keyDwn;

function load() {
  var jg = new jsGraphics("Canvas");
  GG=jg;
  jg.setStroke(1);
  jg.setColor("#999999");
  var dc = document;
  hidectrl(dc.getElementById("stats"));
  drawpalette();
}
function drawpalette() {
  var w = Width, dc = document;
  var e = dc.getElementById("stats");
  var s = "Hello World";

  dc.statss.statwin.value = s;
  if (e.style.visibility == "hidden") showctrl(e);
  dc.getElementById("colorname").value = " Drawing "+nColors+" Colors";
  var i;
  for (i=0;i < nColors; i++) colorpatch(i,w);

  GG.paint();
  dc.getElementById("colorname").value = " Finished Drawing "+nColors+" Colors";
}
function showctrl(dcp) {
  dcp.style.visibility = "visible";
}
function hidectrl(dcp) {
  dcp.style.visibility = "hidden";
}

function hidestatwin() {
  hidectrl(document.getElementById("stats"));
}

function echoadd() {
  var dc = document;
  var e = dc.getElementById("stats")
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s + " " + arg[i];
  dc.statss.statwin.value =
  dc.statss.statwin.value + s.toString();
  if (e.style.visibility == "hidden") showctrl(e);
  // if (timmm) clearTimeout(timmm);
}
function echo(s) {
  document.statss.statwin.value = s.toString();
}

function mouseDwn(e) {
  var IE = 0;
  var b = IE? event.button: e.which;
  var shft = IE? event.shiftKey:e.shiftKey;
  if (b == 1) {
    var d;
    if (IE) {  // IE case e.pageX == null
      d= (document.documentElement && 
      document.documentElement.scrollLeft != null) ?
      document.documentElement : document.body;
      mousex= event.clientX + d.scrollLeft;
      mousey= event.clientY + d.scrollTop;
    } 
    else { mousex= e.pageX; mousey= e.pageY; }
    mousey = mousey - 22;

  var m = Math.floor(Width/patchSize);
  if (mousex < (patchSize * m)) {
    echo(" ");
    // drawpalette();
    m = whichcolor();
    // echo(mousex); echoadd(mousey);  echoadd(n);
    buffer(m);
   }
  }
  return true;
}
function clamp(a,n,m) {
  if (a < n) return n;
  if (a > m) return m;
  return a;
}
function buffer(i) {
  var n = clamp(i, 0, nColors-1);
  document.getElementById("colorname").value = color[n];
  clipboard();
}
function whichcolor() {
  var m = Math.floor(Width/patchSize);
  if (mousex > (patchSize * m)) { echo("off edge"); return 0; }
  if (mousey < 0) { echo("before edge"); return 0; }

  var x = Math.floor(mousex/patchSize);
  var y = Math.floor(mousey/patchSize);
  var i = m * y + x;
  if (i >= nColors) echo("No more colors.");
  return i;
}
/// THUMB NAIL
function colorpatch(i,w) {
  var sz = patchSize, c = "#000000";
  var s = color[i];
  var t = s.split(" ");
  if (t[3] == "White*") c = float2hex(t[4]);
  if ((t.length == 5) && (i < 9)) c = float2hex(t[4]);
  else if ((t[3] == "color") && (t[4] == "red")) c = color2hex(t[5],t[7],t[9]);
  else if ((t[3] == "color") && (t[4] == "rgb")) c = arr2hex(t[5],t[6],t[7]);
  else if (t[3] == "rgb") c = arr2hex(t[4],t[5],t[6]);

// "#declare MediumSlateBlue = color red 0.498039 green 0.5 blue 1.0;" ,
// "#declare MediumSpringGreen = color red 0.498039 green 1.0 blue 0.5;" ,
// had no green blue --- yellow had no spaces
// ? "#declare Mica = color Black; // needed in textures.inc" , fits nothing
//"#declare OrangeRed = color red 1.0 green 0.25 blue 0.0;" no blue
// document.getElementById("colorname").value = c;

  var m = Math.floor(w/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor(c);
  GG.fillRect(x,y,sz,sz);
}
function float2hex(a) {
var b = Math.floor(parseFloat("" + a)*255.0);
  var c = new Array(b,b,b);
  return RGB2Hex(c);
}
function color2hex(a,b,c) {
  var c = new Array(Math.floor(parseFloat(a)*255.0),
  Math.floor(parseFloat(b)*255.0),
  Math.floor(parseFloat(c)*255.0));
  return RGB2Hex(c);
}
function arr2hex(a,b,c) {
  var d = a, e = b, f = c;
  if (a.substr(0,1) == "<") {
    d = a.substr(1);
  }
  var c = new Array(Math.floor(parseFloat(d)*255.0),
  Math.floor(parseFloat(e)*255.0),
  Math.floor(parseFloat(f)*255.0));
  return RGB2Hex(c);
}

function _String() {
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s + " " + arg[i];
  return s;
}
function intr(num) {
  var n = Math.floor(Math.abs(num));
  if (num < 0) n = n * -1;
  return n;
}
function RGB2Hex(n) { // n = array(3) or string with commas
  var d2h="", a, b;
  if (n.length == 3) n = _String(n); // args for _String() = 1;
  var rgb = n.split(","); // string array becomes 1,1,1 automatically
  // and parseInt not needed for rgb[i]
  var hexa = new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");
  for (var i=0;i<3;i++) {
    a = Math.floor(rgb[i] / 16);
    b = intr(rgb[i]) - a * 16;
    d2h += hexa[a];
    d2h += hexa[b];
  }
  return "#"+d2h;
}